function [heightslist, heightsim] = CalculateContourHeights(edgelist, edgeim)

global ROWS;
global COLS;
global EMPTYMARK;
global BASE_EDGE;
global BASE_EDGE_LEN;
global CURR_CONT;
global IS_UP;
global CURR_CORD;
global CURR_LEVEL;

EMPTYMARK = uint32(99999);
[ROWS, COLS] = size(edgeim);


heightslist = repmat(EMPTYMARK, 1, size(edgelist, 2));

heightsim = zeros(ROWS,COLS);

% Find longest edge (we'll take it as a zero height)
BASE_EDGE_LEN = 0;
for c=1:size(edgelist, 2)
    if (size(edgelist{c},1) > BASE_EDGE_LEN)
        BASE_EDGE = c;
        BASE_EDGE_LEN = size(edgelist{c},1);
    end        
end


% TODO: Select larger part of the map

% Calc upwords first
IS_UP = 1;

CURR_CORD = edgelist{BASE_EDGE}(1,:);
CURR_LEVEL = 0;

% Run on the borders and handle open edges
for c=1:ROWS*COLS-1

    % Check if contour found
    if (edgeim(CURR_CORD(1), CURR_CORD(2)) ~= 0)

        %Check if contour is not assigned
        if (heightslist(edgeim(CURR_CORD(1), CURR_CORD(2))) == EMPTYMARK)
            
            % Assign contour height
            heightslist(edgeim(CURR_CORD(1), CURR_CORD(2))) = CURR_LEVEL;
            
            % fillup heights
            for k=1:size(edgelist{edgeim(CURR_CORD(1), CURR_CORD(2))},1)
                heightsim(edgelist{edgeim(CURR_CORD(1), CURR_CORD(2))}(k,1),edgelist{edgeim(CURR_CORD(1), CURR_CORD(2))}(k,2)) = CURR_LEVEL;
            end
        else
            IS_UP = IS_UP * -1;
        end
            
        CURR_LEVEL = CURR_LEVEL + IS_UP;
    else
        
        % Used for estimation of closed contours at the next phase
        heightsim(CURR_CORD(1), CURR_CORD(2)) = CURR_LEVEL;
    end

    % Update current cordinate
    if (CURR_CORD(1) == 1 && CURR_CORD(2) < COLS)
        CURR_CORD(2) = CURR_CORD(2) + 1;
    else
        if (CURR_CORD(2) == COLS && CURR_CORD(1) < ROWS)
            CURR_CORD(1) = CURR_CORD(1) + 1;
        else
            if (CURR_CORD(1) == ROWS && CURR_CORD(2) > 1)
                CURR_CORD(2) = CURR_CORD(2) - 1;
            else
                CURR_CORD(1) = CURR_CORD(1) - 1;
            end
        end
    end
    
end

% Sort the closed contours by their size
closedindices = find(heightslist==EMPTYMARK);
contsizes=zeros(1,size(closedindices,2));
for c=1:size(closedindices,2)
    contsizes(c) = size(edgelist{closedindices(c)},1);
end

% descending order is not working well (probably a bug)
[B, sortedindices] = sort(contsizes, 'ascend');

% Loop on contours in descending order
for c=size(closedindices,2):-1:1
    CURR_CONT = edgelist{closedindices(sortedindices(c))}(1,:);

    % Find neighbor
    CURR_CORD = CURR_CONT;
    CURR_CORD(1) = CURR_CORD(1)-1;
    while (heightsim(CURR_CORD(1), CURR_CORD(2)) == 0)
        CURR_CORD(1) = CURR_CORD(1) - 1;
    end
    
    % %%%%%%%% Maybe we should consider discovering the direction
    % %%%%%%%%%%% of the elevation somehow
    CURR_LEVEL = heightsim(CURR_CORD(1), CURR_CORD(2)) + 1;
    
    % Assign contour height
    heightslist(edgeim(CURR_CONT(1), CURR_CONT(2))) = CURR_LEVEL;

    % fillup heights
    for k=1:size(edgelist{edgeim(CURR_CONT(1), CURR_CONT(2))},1)
        heightsim(edgelist{edgeim(CURR_CONT(1), CURR_CONT(2))}(k,1),edgelist{edgeim(CURR_CONT(1), CURR_CONT(2))}(k,2)) = CURR_LEVEL;
    end
    
end
