function [newedgelist, newedgeim] = EliminateUncompleteEdges (edgelist, edgeim)

global ROWS;
global COLS;

newedgeim = zeros(ROWS,COLS);
newedgelist = [];

[ROWS, COLS] = size(edgeim);

iter = 0;

for c=1:size(edgelist,2)
    
    % check if edge is not complete
    
    % check if not too small (noise)
    if (size(edgelist{c},1) < 5) 
        continue;
    end
        
    % check if not closed edge
    if  (abs(edgelist{c}(1,1) - edgelist{c}(end,1)) + abs(edgelist{c}(1,2) - edgelist{c}(end,2)) > 2)
        
        % check if starts not at the border
        if  (edgelist{c}(1,1) ~= 1 && edgelist{c}(1,1) ~= ROWS && edgelist{c}(1,2) ~= 1 && edgelist{c}(1,2) ~= COLS) 
            continue;
        end

        % check if ends not at the border
        if (edgelist{c}(end,1) ~= 1 && edgelist{c}(end,1) ~= ROWS && edgelist{c}(end,2) ~= 1 && edgelist{c}(end,2) ~= COLS)
            continue;
        end
    end
    
    % Copy edge to the output list
    iter = iter + 1;
    if (size(newedgelist,2) == 0)
        newedgelist = {edgelist{c}};
    else
        newedgelist = {newedgelist{:} edgelist{c}};
    end

    % update map
    for t=1:size(edgelist{c},1)
        newedgeim(edgelist{c}(t,1),edgelist{c}(t,2)) = iter;
    end
    
    
    
end