function [newedgelist, newedgeim] = FindEdgeContinuation (edgelist, edgeim, windowsize)

global ROWS;
global COLS;

global CURRSIZE;


newedgelist = edgelist;
newedgeim = edgeim;

[ROWS, COLS] = size(edgeim);

% Run on available edges
for c=1:size(newedgelist,2)
    
    % Current edge size
    CURRSIZE = size(newedgelist{c},1);
    
    if (CURRSIZE == 0) 
        continue;
    end
    
    %check window on both ends
    for e=1:CURRSIZE-1:CURRSIZE
        
        BestFitContinuation = [0 0 0 0]; %[index, ,error, y, x]
        
        % find continuation only if not near the border
        if  (newedgelist{c}(e,1) ~= 1 && newedgelist{c}(e,1) ~= ROWS && newedgelist{c}(e,2) ~= 1 && newedgelist{c}(e,2) ~= COLS)

            % Run on the window
            for y=newedgelist{c}(e,1) - windowsize: newedgelist{c}(e,1) + windowsize
                for x=newedgelist{c}(e,2) - windowsize: newedgelist{c}(e,2) + windowsize
                    
                    % 1) The coordinate is inside the image
                    % 2) The coordinate is an edge part
                    % 3) The coordinate is not the current edge
                    if ~(y > 0 && y <= ROWS && x > 0 && x <= COLS && newedgeim(y,x) > 0 && newedgeim(y,x) ~=  c)
                        continue;
                    end
                    
                    p = newedgelist{newedgeim(y,x)}(1,:);
                    q = newedgelist{newedgeim(y,x)}(end,:);
                    % 4) The coordinate is the end point of the edge
                    if ~(all(newedgelist{newedgeim(y,x)}(1,:) == [y, x]) || all(newedgelist{newedgeim(y,x)}(end,:) == [y, x]))
                        continue;
                    end


                    %%%%%%%%%%%%%% ERROR METRICA %%%%%%%%%%%%%%%%%     
                    err = (newedgelist{c}(e,1) - y).^2 + (newedgelist{c}(e,2) - x).^2;
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

                    if (BestFitContinuation(1) == 0 || BestFitContinuation(2) > err)

                        BestFitContinuation(1) = newedgeim(y,x);
                        BestFitContinuation(2) = err;
                        BestFitContinuation(3) = y;
                        BestFitContinuation(4) = x;
                    end
                end
            end
            
            if (BestFitContinuation(1) == 0)
                continue;
            end
            
            %%%%%%%%%%%%% Merge 2 edges %%%%%%%%%%%%%%%
            
            % Draw line between discovered pixels
            newLine = linepixels(newedgelist{c}(e,2), newedgelist{c}(e,1), BestFitContinuation(4), BestFitContinuation(3));
            
            % Check if we are handling the first point in the array
            if (e == 1)
                newLine = flipud(newLine); %flip line direction
                newedgelist{c} = [newLine(1:end-1,:); newedgelist{c}]; % expanding current edge
            
                if (all(newedgelist{BestFitContinuation(1)}(1) == [y, x]))
                    newedgelist{BestFitContinuation(1)} = flipud(newedgelist{BestFitContinuation(1)});
                end
                
                newedgelist{c} = [newedgelist{BestFitContinuation(1)}; newedgelist{c}(2:end,:)];
                
            else
                newedgelist{c} = [newedgelist{c}; newLine(2:end,:)]; % expanding current edge
                
                if (all(newedgelist{BestFitContinuation(1)}(1) ~= [y, x]))
                    newedgelist{BestFitContinuation(1)} = flipud(newedgelist{BestFitContinuation(1)});
                end
                
                newedgelist{c} = [newedgelist{c}(1:end-1,:); newedgelist{BestFitContinuation(1)}];
                
            end
            
            %%%%%%%%%% Erase processed edge %%%%%%%%%%%%
            
            for i=1:size(newedgelist{BestFitContinuation(1)},1)
                newedgeim(newedgelist{BestFitContinuation(1)}(i,1), newedgelist{BestFitContinuation(1)}(i,2)) = c;
            end
            
            newedgelist{BestFitContinuation(1)} = [];
            
            
            
        end
        
        
    end
    
    
end