clc;
close all;

% Load map image
IuintRgb = imread('Yaar Yeshai small.tif');
imshow(IuintRgb);

%%%%%%%%%%%%%%%%%%%%%%%%%% Color Filters calculation  (Phase 1) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Converting to HSV color space
Ihsv = rgb2hsv(IuintRgb);
 
% Filtering black
BlackMapFilter = (Ihsv(:,:,3) > 0.25);

 %Filtering white
 WhiteMapFilter = ~((Ihsv(:,:,3) > 0.70) & (Ihsv(:,:,2) < 0.20));

% H=(Ihsv(:,:,1));
% S=(Ihsv(:,:,2));
% V=(Ihsv(:,:,3));

% The rest histogram between 0 and 0.2 of Hue is the brown color
%imhist(CountorsMap(:,:,1));
BrownMapFilter = Ihsv(:,:,1) < 0.2 & Ihsv(:,:,2) > 0.25; % Right contraint selected by Miro

%%%%%%%%% My own %%%%%%%%%%%
%TooDarkMapFilter = Ihsv(:,:,2) < 0.7;

%%%%%%%%%%%%%%%%%%%%%%%% Apply color filters %%%%%%%%%%%%%%%%%%%

% Apply filters
ContoursMap = Ihsv;
ContoursMap(:,:,3) = Ihsv(:,:,3) .* BrownMapFilter .* BlackMapFilter .* WhiteMapFilter;% ~= 0;

%imhist(ContoursMap(:,:,2));
%figure; imshow(ContoursMap(:,:,3));

%%%%%%%%%%%%%%%%%%%%%%%%%% Threshold %%%%%%%%%%%%%%%%%%%%%%%%%%
% http://blogs.mathworks.com/steve/?p=36
I=hsv2rgb(ContoursMap);
Ithreshold = graythresh(I);
Ibw = im2bw(I, Ithreshold);
%figure; imshow(Ibw);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Remove Noise ??? %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Idenoised = imnoise(uint8(Ithinned), 'salt & pepper', 0.02);
Idenoised = medfilt2(Ibw, [2 2]);
figure; imshow(Idenoised);

%%%%%%%%%%%%%%%%%%%%%%%%%%% Thinning  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%I = skeleton(Ibw);
%figure; imshow(I);
Ithinned = bwmorph(Idenoised, 'thin', inf);
figure; imshow(Ithinned);
%imwrite(Ithinned, 'out.tif', 'tif');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Smoothing %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%PSF = fspecial('laplacian');
%J = deconvreg(I, PSF);
%figure; imshow(J);

%%%%%%%%%%%%%%%%%%%%%%%%%% Edge linking %%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% NOT FINISHED YET


%XXXXXXXXXXXXXXXX Load manually fixed file (Phase 2) XXXXXXXXXXXXXXXXXXXXX
Icontinous = imread('Yaar Yeshai small - fixed contours.tif');
figure; imshow(Icontinous);

%%%%%%%%%%%%%%%%% Thinning again %%%%%%%%%%%%%%%%%%%%%%%%%%
Ithinned = bwmorph(Icontinous, 'thin', inf);
figure; imshow(Ithinned);

%%%%%%%%%%%%%%%%% Edge building %%%%%%%%%%%%%%%%%%
 [edgelist, labelededgeim] = edgelink(Ithinned);
%figure;  drawedgelist(edgelist, size(Ithinned), 1, 'rand', 3); axis off
 lineslist = lineseg(edgelist, 1);
 %drawedgelist(seglist, size(Ithinned), 2, 'rand', 4); axis off

%Q = edge(Ithinned, 'canny');
%imshow(Q);

%%%%%%%%%%%%%%%%%% Remove uncompleted edges %%%%%%%%%%%%%%%%%%%%
[edgelist, labelededgeim] = EliminateUncompleteEdges(edgelist, labelededgeim);
Iclean = labelededgeim > 0;
figure; imshow(Iclean);

%%%%%%%%%%%%%%%% Calculate Contour Heights (Phase 3) %%%%%%%%%%%%%%%% 
[heightslist, heightim] = CalculateContourHeights(edgelist, labelededgeim);



%%%%%%%%%%%%%%%%%% 3D (Phase 4) %%%%%%%%%%%%%%%%%%%%%%%%%%%
% TODO


%%%%%%%%%%%%%%%%%%%%%%%%%%%% Result display %%%%%%%%%%%%%%%%%%%%%%%%
%IRgbOut=hsv2rgb(ContoursMap);
%figure; imshow(IRgbOut);
imwrite(Iclean, 'out.jpg', 'jpg');
